﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;


namespace FlexChartImageSave
{
    public partial class FlexChartPage : ContentPage
    {
        public FlexChartPage()
        {
            InitializeComponent();
            FlexChartDataSource ds = new FlexChartDataSource();
            flexChart.ItemsSource = ds.Data;
            Device.OnPlatform(iOS: ()=> flexChart.BackgroundColor = Color.White, Android: ()=> flexChart.BackgroundColor = Color.Default, WinPhone: ()=> flexChart.BackgroundColor = Color.Black);
            //Accomodates iOS status bar
            this.Padding = new Thickness(10, Device.OnPlatform(20, 0, 0), 10, 5);
        }
        async void OnButtonClicked(object sender, EventArgs args)
        {
            Button button = (Button)sender;   
            //uses the IPicture interface to use the appropriate saving mechanism from the picture class in each individual project
            DependencyService.Get<IPicture>().SavePictureToDisk("ChartImage", flexChart.GetImage());
            //generic success message
            await DisplayAlert("Image Save",
                "The image has been saved",
                "OK");      
        }
    }
}
